/* This is a very dumb implementation of a property file writer and reader.*/
/* You can put comments in a property file by starting the line with a #
/* Current limitation: no spaces in property names.*/

#include "PropertyList.h"
#include <stdio.h>

PropertyList::PropertyList() {
	hash = new Hashtable();
	fileName = NULL;
}

PropertyList::PropertyList(const char* fromFile) {
	hash = new Hashtable();
	fileName = NULL;
	
	read(fromFile);
}

PropertyList::~PropertyList() {
	if (fileName != NULL)
		free(fileName);
	hash->resetEnumerator();
	
	while (hash->hasMoreKeys()) {
		free(hash->get(hash->nextKey()));
	}
	delete(hash);
}
	
bool PropertyList::read(const char* fromFile) {
	setFileName(fromFile);
	return read();
}

bool PropertyList::read() {
	FILE* file = fopen(fileName, "rb");
	if (!file)
		return false;
	
	while (fgets(lineBuff, MAX_PROPERTY_LINE_LENGTH, file)) {
		if (parseLine(lineBuff))
			setProperty(gProp, gValue);
	}
	fclose(file);
	return true;
}
	
int PropertyList::getPropertyi(const char* propName) {
	if (hash->containsKey(propName))
		return atoi((char*)hash->get(propName));
	else
		return 0;
}

float PropertyList::getPropertyf(const char* propName) {
	if (hash->containsKey(propName))
		return (float) atof((char*)hash->get(propName));
	else
		return 0;
}

double PropertyList::getPropertyd(const char* propName) {
	if (hash->containsKey(propName))	
		return atof((char*)hash->get(propName));
	else
		return 0;
}

char*  PropertyList::getPropertys(const char* propName) {
	if (hash->containsKey(propName))
		return (char*)hash->get(propName);
	else
		return NULL;
}
	
void PropertyList::setProperty(const char* propName, const char* value) {
	char* strPtr = (char*)malloc(strlen(value)+1);
	strcpy(strPtr, value);
	hash->put(propName, strPtr);
}

void PropertyList::setProperty(const char* propName, int value) {
	sprintf(gValue, "%d", value);
	setProperty(propName, gValue);
}

void PropertyList::setProperty(const char* propName, float value) {
	sprintf(gValue, "%f", value);
	setProperty(propName, gValue);
}

void PropertyList::setProperty(const char* propName, double value) {
	sprintf(gValue, "%f", value);
	setProperty(propName, gValue);
}

	
bool PropertyList::write(const char* toFile) {
	setFileName(toFile);
	
	return write();
}

bool PropertyList::write() {
	if (fileName == NULL)
		return false;

	FILE* file = fopen(fileName, "wb");
	if (!file)
		return false;
	
	char* key;
	
	hash->resetEnumerator();

	while (hash->hasMoreKeys()) {
		key = hash->nextKey();
		if (strlen(key) > 0)
			fprintf(file, "%s %s\n", key, (char*)hash->get(key));
	}


	fclose(file);
	return true;
}

void PropertyList::stripToQuotes() {
	if (gValue[0] != '\"')
		return;
	
	char* endQuotePtr = strrchr ( gValue + 1, '\"' );	// Get ptr to last quote
	if (endQuotePtr == NULL)
		return;
	
	char* copyPtr;
	for (copyPtr = gValue + 1; copyPtr < endQuotePtr; copyPtr++) {
		*(copyPtr - 1) = *copyPtr;
	}
	*(copyPtr-1) = 0;
}

bool PropertyList::parseLine(const char* line) {
	int lineLength = strlen(line);
	if (lineLength < 1 || line[0] == '#')
		return false;
		
	gProp[0] = 0;
	gValue[0] = 0;
	
	
	char divider = '.';
	int  i = 0;
	while (i < lineLength && line[i] != ' ') {
		gProp[i] = line[i];
		gProp[i+1] = 0;
		i++;
	}
	while (i < lineLength && line[i] == ' ')
		i++;
		
	int j = i;
		
	while (i < lineLength) {
		gValue[i-j] = line[i];
		gValue[i+1-j] = 0;
		i++;
	}
	
	stripToQuotes();
	return true;
}

void PropertyList::setFileName(const char* newFileName) {
	if (fileName != NULL)
		free(fileName);
	fileName = (char*)malloc(strlen(newFileName)+1);
	strcpy(fileName, newFileName);
}