#ifndef _PROPERTY_LIST_H_
#define _PROPERTY_LIST_H_


#include <string.h>

#include "Hashtable.h"

#define MAX_PROPERTY_LINE_LENGTH 256

class PropertyList {
	public:
	PropertyList();
	PropertyList(const char* fromFile);
	~PropertyList();
	
	bool read();
	bool read(const char* fromFile);
	
	int getPropertyi(const char* propName);
	float getPropertyf(const char* propName);
	double getPropertyd(const char* propName);
	char*  getPropertys(const char* propName);
	
	void setProperty(const char* propName, const char* value);
	void setProperty(const char* propName, int value);
	void setProperty(const char* propName, float value);
	void setProperty(const char* propName, double value);
	
	bool write(const char* toFile);
	bool write();
	
	void setFileName(const char* newFileName);

	private:
	bool parseLine(const char* line);
	void stripToQuotes();
	
	char*      fileName;
	Hashtable* hash;
	char       lineBuff[MAX_PROPERTY_LINE_LENGTH];
	char 			 gProp[MAX_PROPERTY_LINE_LENGTH];
	char 		   gValue[MAX_PROPERTY_LINE_LENGTH];

};



#endif